from Crypto.Cipher import AES
from itertools import product
import time

# Verschlüsselten Datenstrom laden
with open('encrypted_file_aes.bin', 'rb') as f:
    ciphertext = f.read()

start_time = time.time()  # Startzeit

# Brute-Force-Funktion für AES mit 256-Bit Schlüssel
def brute_force_aes_256bit(ciphertext):
    key_space = (b''.join(k) for k in product(b'abc123', repeat=32))  # Beispiel für 256-Bit Schlüsselraum
    target_pattern = b"Das ist eine Text-Datei!"  # Gesuchter Inhalt
    for key in key_space:
        try:
            cipher = AES.new(key, AES.MODE_ECB)
            plaintext = cipher.decrypt(ciphertext)
            if target_pattern in plaintext:
                print(f"Schlüssel gefunden: {key}")
                print(f"Entschlüsselter Inhalt: {plaintext.decode()}")
                return plaintext
        except Exception as e:
            continue

end_time = time.time()
plaintext = brute_force_aes_256bit(ciphertext)
if plaintext:
    print("Datei erfolgreich entschlüsselt!")
else:
    print("Kein gültiger Schlüssel gefunden.")

duration = end_time - start_time
print(f"Dauer des Angriffs: {duration:.2f} Sekunden")
