### Folder Structure

- **Certificates**  
    -  This folder contains the communication certificates that have been created. These certificates are generated by the `certificateCreation.sh` script located in the **Setup** folder

- **CommunicationScripts**  
    - This folder includes the server and client scripts that build the end-to-end communication between the two Raspberry Pis

- **EncryptedData**  
    - This folder stores the encrypted data collected during the communication between the two devices

- **DecryptionScripts**  
    - This folder contains scripts designed to decrypt the collected binary data. These scripts process the encrypted data and inform if the enrcyption was successful or not

- **Setup**  
    - This folder includes essential setup scripts and configuration files to prepare the environment:
        - `certificateCreation.sh`: A script that generates all necessary certificates for secure communication
        - `decryption.sh`: A script that installs the required libraries and dependencies needed to execute the decryption scripts
        - `wolfsslInstallation`: A script to install and configure the `wolfSSL` library, which is used for secure communication between the devices
